/*
 * This file is a part of Winix
 * and is distributed under the 2-Clause BSD licence.
 * Author: Tomasz Sowa <t.sowa@ttmath.org>
 */

/*
 * Copyright (c) 2022, Tomasz Sowa
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include "pgmodeler.h"
#include "html/htmlparser.h"
#include "misc.h"



namespace Winix
{


PGModeler::PGModeler()
{
}

PGModeler::~PGModeler()
{
}




bool PGModeler::parse(const std::wstring & input_file, pt::Space & schema)
{
	schema.clear();
	pt::HTMLParser parser;

	pt::HTMLParser::Status status = parser.parse_xml_file(input_file, schema, true, true);

	if( status == pt::HTMLParser::Status::cant_open_file )
	{
		print("cannot open the input file", input_file);
		return false;
	}
	else
	if( status == pt::HTMLParser::Status::syntax_error )
	{
		print("syntax error", input_file, parser.get_last_parsed_line());
		schema.clear();
		return false;
	}
	else
	{
		parse(schema);
	}

	return true;
}


bool PGModeler::parse(pt::Space & schema)
{
	std::string tmp;

//	schema.serialize_to_json_to(tmp, true);
//	std::cout << tmp << std::endl;

	return true;
}


}

